/*
	Copyright (C) 1994 Sean Luke

	COWSIPCLibrary.h
	Version 1.0
	Sean Luke
	
*/




#import "COWSLibrary.h"
#import "COWSInterpreter.h"
#import <string.h>
#import <stdlib.h>
#import <stdio.h>
#import <remote/NXConnection.h>
#import "COWSProtocols.h"


#define	COWSIPCLIBRARY_ARGSTATE_READY	0
#define COWSIPCLIBRARY_ARGSTATE_WORKING	1
#define COWSIPCLIBRARY_ARGSTATE_ADDING	2
#define COWSLARGESTPATHLENGTH			MAXHOSTNAMELEN+100

@interface COWSIPCLibrary:COWSLibrary <InterpreterToLibrary,InterpreterIPC,InterpreterToAppDelegate>
{
	id 			interpreter;
	BOOL		error;
	id			connection;
	id			caller;
	COWSArgumentList*	arguments;
	int			arguments_state;
	COWSStringNode*	result;
}

- init;
- loadLibrary:sender;
- pauseCancelled:sender;
- pauseInterpreter:remote_process;

// COWS functions

- ipc_send:arg_list;			// synchronous to same machine
- ipc_sendout:arg_list;			// asynchronous to same machine
- ipc_send_machine:arg_list;	// synchronous to different machine
- ipc_sendout_machine:arg_list;	// asynchronous to different machine
- ipc_launch:arg_list;			// launches to same machine or different
- ipc_launched:arg_list;			// checks on same machine or different

// COWS libraries are registered as APPNAME(COWS) where APPNAME is the app's
// name.  For example, Edit would be Edit(COWS).

- finishedInterpreting:(const char*)returnValue:(int)thisMessage:sender;
- errorInterpreting:(int) thisError:(const char*)thisFunction:
	(int)thisPosition:(const char*)thisString:sender;


@end